com.fasterxml.jackson.databind.deser.std

## Class EnumDeserializer.FactoryBasedDeserializer

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonDeserializer<T>
  - - com.fasterxml.jackson.databind.deser.std.StdDeserializer<T>
    - - com.fasterxml.jackson.databind.deser.std.StdScalarDeserializer<Object>
      - - com.fasterxml.jackson.databind.deser.std.EnumDeserializer.FactoryBasedDeserializer

All Implemented Interfaces:
  Serializable

Enclosing class:
  EnumDeserializer

    protected static class EnumDeserializer.FactoryBasedDeserializer
    extends StdScalarDeserializer<Object>

Deserializer that uses a single-String static factory method for locating Enum values by String id.

See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonDeserializer

`JsonDeserializer.None`

### Field Summary

Fields
`protected Class<?>` `_enumClass`
`protected Method` `_factory`
`protected Class<?>` `_inputType`

### Fields inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

`_valueClass`

### Constructor Summary

Constructors
Constructor and Description
`EnumDeserializer.FactoryBasedDeserializer(Class<?> cls, AnnotatedMethod f, Class<?> inputType)`

### Method Summary

Methods
`Object` `deserialize(com.fasterxml.jackson.core.JsonParser jp, DeserializationContext ctxt)` Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles.

### Methods inherited from class com.fasterxml.jackson.databind.deser.std.StdScalarDeserializer

`deserializeWithType`

### Methods inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

`_hasTextualNull, _parseBoolean, _parseBooleanFromNumber, _parseBooleanPrimitive, _parseByte, _parseDate, _parseDouble, _parseDoublePrimitive, _parseFloat, _parseFloatPrimitive, _parseInteger, _parseIntPrimitive, _parseLong, _parseLongPrimitive, _parseShort, _parseShortPrimitive, _parseString, findConvertingContentDeserializer, findDeserializer, getValueClass, getValueType, handledType, handleUnknownProperty, isDefaultDeserializer, isDefaultKeyDeserializer, parseDouble`

### Methods inherited from class com.fasterxml.jackson.databind.JsonDeserializer

`deserialize, findBackReference, getDelegatee, getEmptyValue, getKnownPropertyNames, getNullValue, getObjectIdReader, isCachable, replaceDelegatee, unwrappingDeserializer`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### _enumClass

    protected final Class<?> _enumClass

#### _inputType

    protected final Class<?> _inputType

#### _factory

    protected final Method _factory

### Constructor Detail

#### EnumDeserializer.FactoryBasedDeserializer

    public EnumDeserializer.FactoryBasedDeserializer(Class<?> cls,
                                             AnnotatedMethod f,
                                             Class<?> inputType)

### Method Detail

#### deserialize

    public Object deserialize(com.fasterxml.jackson.core.JsonParser jp,
                     DeserializationContext ctxt)
                       throws IOException,
                              com.fasterxml.jackson.core.JsonProcessingException

Description copied from class: `JsonDeserializer`
Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles. Returned instance is to be constructed by method itself.

Pre-condition for this method is that the parser points to the first event that is part of value to deserializer (and which is never JSON 'null' literal, more on this below): for simple types it may be the only value; and for structured types the Object start marker. Post-condition is that the parser will point to the last event that is part of deserialized value (or in case deserialization fails, event that was not recognized or usable, which may be the same event as the one it pointed to upon call).

Note that this method is never called for JSON null literal, and thus deserializers need (and should) not check for it.

Specified by:
  `deserialize` in class `JsonDeserializer<Object>`
Parameters:
  `jp` - Parsed used for reading JSON content
  `ctxt` - Context that can be used to access information about this deserialization activity.
Returns:
  Deserialized value
Throws:
  `IOException`
  `com.fasterxml.jackson.core.JsonProcessingException`